{ TCharLed  TDigitClock.     
          .
       (   
  )   : www.chat.ru/~z_ol
           Delphi,
      .

  (c)  .. e-mail: merlin_twi@mail.ru
}

unit CharLed;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type
  TChar = 0..12;
  TLed = (sg_0, sg_1, sg_2, sg_3, sg_4, sg_5, sg_6, sg_7, sg_8);
  TLeds = set of TLed;
  TCharLed = class(TGraphicControl)
  private
    FLeds: TLeds;
    FCharWidth,
    FCharHeight: Integer;
    FCharColor: TColor;
    FBorderColor: TColor;
    FBorderWidth: Integer;
    FTransparent: boolean;
  protected
    procedure Paint; override;
    procedure SetCharWidth(Value: Integer);
    procedure SetCharHeight(Value: Integer);
    function GetChar: TChar;
    procedure SetChar(Value: TChar);
    procedure SetLeds(Value: TLeds);
    procedure SetCharColor(Value: TColor);
    procedure SetBorderColor(Value: TColor);
    procedure SetBorderWidth(Value: Integer);
    procedure SetTransparent(Value : boolean);
  public
    constructor Create(AOwner: TComponent); override;
  published
    property CharWidth: Integer read FCharWidth
      write SetCharWidth default 8;
    property CharHeight: Integer read FCharHeight
      write SetCharHeight default 8;
    property Char: TChar read GetChar write SetChar default 8;
    property Leds: TLeds read FLeds write SetLeds;
    property CharColor: TColor read FCharColor
      write SetCharColor default clLime;
    property BorderColor: TColor read FBorderColor
      write SetBorderColor default clBlack;
    property BorderWidth: Integer read FBorderWidth
      write SetBorderWidth default 2;
    property Transparent: boolean read FTransparent
      write SetTransparent default true;
    property Color;
    property Cursor;
    property DragCursor;
    property DragMode;
    property ParentColor;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property Visible;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDrag;
    property Width default 33;
    property Height default 49;
  end;

  TDigitClock = class(TCustomPanel)
  private
    { Private declarations }
    FTimer: TTimer;
    FActive: Boolean;
    FCharLeds: array [1..7] of TCharLed;
    FShowSeconds: Boolean;
    FSpaceWidth: Integer;
  protected
    { Protected declarations }
    procedure SetShowSeconds(Value: Boolean);
    procedure SetCharColor(Value: TColor);
    function GetCharColor: TColor;
    procedure SetBorderColor(Value: TColor);
    function GetBorderColor: TColor;
    procedure SetCharWidth(Value: Integer);
    function GetCharWidth: Integer;
    procedure SetCharBorderWidth(Value: Integer);
    function GetCharBorderWidth: Integer;
    procedure SetCharHeight(Value: Integer);
    function GetCharHeight: Integer;
    procedure SetActive(Value: Boolean);
    procedure SetSpaceWidth(Value: Integer);
    procedure Adjust;
    procedure Resize; override;
    procedure ActTimer(Sender: TObject);
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    { Published declarations }
    property ShowSeconds: Boolean read FShowSeconds write SetShowSeconds
      default True;
    property Active: Boolean read FActive write SetActive default True;
    property CharColor: TColor read GetCharColor write SetCharColor default clLime;
    property CharWidth: Integer read GetCharWidth write SetCharWidth default 3;
    property CharBorderWidth: Integer read GetCharBorderWidth write SetCharBorderWidth;
    property CharHeight: Integer read GetCharHeight write SetCharHeight default 3;
    property SpaceWidth: Integer read FSpaceWidth write SetSpaceWidth default 4;
    property BorderColor: TColor read GetBorderColor write SetBorderColor default clBlack;
    property Align;
    property Color default clBlack;
    property Cursor;
    property DragCursor;
    property DragMode;
    property ParentColor;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnResize;
    property OnStartDrag;
    property Width default 137;
    property Height default 25;
    property BevelOuter default bvNone;
  end;

procedure Register;

implementation

procedure Register;
begin
 RegisterComponents('Alex', [TCharLed]);
 RegisterComponents('Alex', [TDigitClock]);
end;
  {
       +-----------------------------------------+    --------+------+
       |                                         |            |(4)   |
       |       +------------------------+        |    --------+      |
       |       |\          0           /|        |            |      |
       |       | \--------------------/ |        |            |      |
       |       |  |                  |  |        |            |      |
       |       |  |      +---+       |  |        |            |      |
       |       | 1|      | 7 |       | 2|        |            |      |
       |       |  |      +---+       |  |        |            |      |
       |       |  |                  |  |        |            |      |
       |       | /--------------------\ |        |            |      |
       |       ++          3           ++        |            |(3)   |(5)
       |       | \--------------------/ |        |            |      |
       |       |  |                  |  |        |            |      |
       |       |  |      +---+       |  |        |            |      |
       |       | 4|      | 8 |       | 5|        |            |      |
       |       |  |      +---+       |  |        |            |      |
       |       |  |                  |  |        |            |      |
       |       | /--------------------\ |        |   -+       |      |
       |       |/          6           \|        |    |(1)    |      |
       |       +------------------------+        |   -+-    --+      |
       |                                         |            |      |
       |                                         |            |(2)   |
       +-----------------------------------------+   ---------+------+
               |  |
               +--+                              |
       |        (6)                              |
       +-------+------------------------+--------+
       |  (7)             (8)               (9)  |
       |                                         |
       +-----------------------------------------+
                         (10)

}

const
  CharToLedsTable: array[TChar] of TLeds = (
    [sg_0,sg_1,sg_2,sg_4,sg_5,sg_6],      // 0
    [sg_2,sg_5],                          // 1
    [sg_0,sg_2,sg_3,sg_4,sg_6],           // 2
    [sg_0,sg_2,sg_3,sg_5,sg_6],           // 3
    [sg_1,sg_2,sg_3,sg_5],                // 4
    [sg_0,sg_1,sg_3,sg_5,sg_6],           // 5
    [sg_0,sg_1,sg_3,sg_4,sg_5,sg_6],      // 6
    [sg_0,sg_2,sg_5],                     // 7
    [sg_0,sg_1,sg_2,sg_3,sg_4,sg_5,sg_6], // 8
    [sg_0,sg_1,sg_2,sg_3,sg_5,sg_6],      // 9
    [sg_7,sg_8],                          // 10 - ':'
    [sg_8],                               // 11 - '.'
    []                                    // 12 - 
  );

function CharToLeds(Char: TChar): TLeds;
begin
  Result := CharToLedsTable[Char];
end;

function LedsToChar(Leds: TLeds): TChar;
var
  i: TChar;
begin
  Result := 12;
  for i := Low(TChar) to High(TChar) do
    if CharToLedsTable[TChar(i)] = Leds then begin
      Result := i; exit;
    end;
end;

procedure TCharLed.Paint;
var
  Points:  array[0..3] of TPoint;
  Points1: array[0..5] of TPoint;
  a, b, x, y: Integer;
begin
  inherited;
  if not Visible then exit;
  a := BorderWidth div 2;
  if BorderWidth > 6 then b := a
  else b := BorderWidth - a;
  if not FTransparent then begin
    Canvas.Brush.Color := Color;
    Canvas.FillRect(Canvas.ClipRect);
  end;
  with Canvas.Pen do begin
    Color := FBorderColor;
    Width := FBorderWidth;
  end;
  with Canvas.Brush do begin
    Color := FCharColor;
  end;
    if sg_0 in FLeds then begin
      Points[0].X := a;
      Points[0].Y := a;
      Points[1].X := a + CharWidth;
      Points[1].Y := a + CharHeight;
      Points[2].X := ClientWidth - CharWidth - b;
      Points[2].Y := a + CharHeight;
      Points[3].X := ClientWidth - b;
      Points[3].Y := a;
      Canvas.Polygon(Points);
    end;
    // 1
    if sg_1 in FLeds then begin
      Points[0].X := a;
      Points[0].Y := a;
      Points[1].X := a + CharWidth;
      Points[1].Y := a + CharHeight;
      Points[2].X := a + CharWidth;
      Points[2].Y := (ClientHeight - CharHeight) div 2;
      Points[3].X := a;
      Points[3].Y := ClientHeight div 2;
      Canvas.Polygon(Points);
    end;
    // 2
    if sg_2 in FLeds then begin
      Points[0].X := ClientWidth - b;
      Points[0].Y := a;
      Points[1].X := ClientWidth - CharWidth - b;
      Points[1].Y := a + CharHeight;
      Points[2].X := ClientWidth - CharWidth - b;
      Points[2].Y := (ClientHeight - CharHeight) div 2;
      Points[3].X := ClientWidth - b;
      Points[3].Y := ClientHeight div 2;
      Canvas.Polygon(Points);
    end;
    // 3
    if sg_3 in FLeds then begin
      Points1[0].X := a;
      Points1[0].Y := ClientHeight div 2;
      Points1[1].X := a + CharWidth;
      Points1[1].Y := (ClientHeight + CharHeight) div 2;
      Points1[2].X := ClientWidth - CharWidth - b;
      Points1[2].Y := (ClientHeight + CharHeight) div 2;
      Points1[3].X := ClientWidth - b;
      Points1[3].Y := ClientHeight div 2;
      Points1[4].X := ClientWidth - CharWidth - b;
      Points1[4].Y := (ClientHeight - CharHeight) div 2;
      Points1[5].X := a + CharWidth;
      Points1[5].Y := (ClientHeight - CharHeight) div 2;
      Canvas.Polygon(Points1);
    end;
    // 4
    if sg_4 in FLeds then begin
      Points[0].X := a;
      Points[0].Y := ClientHeight div 2;
      Points[1].X := a + CharWidth;
      Points[1].Y := (ClientHeight + CharHeight) div 2;
      Points[2].X := a + CharWidth;
      Points[2].Y := ClientHeight - CharHeight - b;
      Points[3].X := a;
      Points[3].Y := ClientHeight - b;
      Canvas.Polygon(Points);
    end;
    // 5
    if sg_5 in FLeds then begin
      Points[0].X := ClientWidth - b;
      Points[0].Y := ClientHeight div 2;
      Points[1].X := ClientWidth - CharWidth - b;
      Points[1].Y := (ClientHeight + CharHeight) div 2;
      Points[2].X := ClientWidth - CharWidth - b;
      Points[2].Y := ClientHeight - CharHeight - b;
      Points[3].X := ClientWidth - b;
      Points[3].Y := ClientHeight - b;
      Canvas.Polygon(Points);
    end;
    // 6
    if sg_6 in FLeds then begin
      Points[0].X := a;
      Points[0].Y := ClientHeight - b;
      Points[1].X := a + CharWidth;
      Points[1].Y := ClientHeight - CharHeight - b;
      Points[2].X := ClientWidth - CharWidth - b;
      Points[2].Y := ClientHeight - CharHeight - b;
      Points[3].X := ClientWidth - b;
      Points[3].Y := ClientHeight - b;
      Canvas.Polygon(Points);
    end;
    if sg_7 in FLeds then begin
      x := (ClientWidth - CharWidth + a - b) div 2;
      y := (a + (ClientHeight - CharHeight) div 2) div 2;
      Canvas.Rectangle(x, y, x + CharWidth + 1, y + CharHeight + 1);
    end;
    if sg_8 in FLeds then begin
      x := (ClientWidth - CharWidth + a - b) div 2;
      y := (ClientHeight - b - CharHeight
        + (ClientHeight - CharHeight) div 2) div 2;
      Canvas.Rectangle(x, y, x + CharWidth + 1, y + CharHeight + 1);
    end;
end;

procedure TCharLed.SetCharWidth(Value: Integer);
begin
  if Value <> FCharWidth then begin
    FCharWidth := Value;
    Invalidate;
  end;
end;

procedure TCharLed.SetCharHeight(Value: Integer);
begin
  if Value <> FCharHeight then begin
    FCharHeight := Value;
    Invalidate;
  end;
end;

procedure TCharLed.SetChar(Value: TChar);
begin
  if Value <> Char then begin
    FLeds := CharToLeds(Value);
    Invalidate;
  end;
end;

procedure TCharLed.SetLeds(Value: TLeds);
begin
  if Value <> FLeds then begin
    FLeds := Value;
    Invalidate;
  end;
end;

function TCharLed.GetChar;
begin
  Result := LedsToChar(FLeds);
end;

procedure TCharLed.SetCharColor(Value: TColor);
begin
  if Value <> FCharColor then begin
    FCharColor := Value;
    Invalidate;
  end;
end;

procedure TCharLed.SetBorderColor(Value: TColor);
begin
  if Value <> FBorderColor then begin
    FBorderColor := Value;
    Invalidate;
  end;
end;

procedure TCharLed.SetBorderWidth(Value: Integer);
begin
  if Value<=0 then Value:=1;
  if (FBorderWidth <> Value) then begin
    FBorderWidth := Value;
    Invalidate;
  end;
end;

procedure TCharLed.SetTransparent;
begin
 if FTransparent<>Value then begin
   FTransparent:=Value;
   Invalidate;
 end;
end;

constructor TCharLed.Create(AOwner: TComponent);
begin
  inherited;
  Width := 33;
  Height := 49;
  Canvas.Pen.Color := clBlack;
  Canvas.Pen.Width := 2;
  Canvas.Brush.Color := clLime;
  FCharColor := clLime;
  FBorderColor := clBlack;
  FBorderWidth := 2;
  FLeds := CharToLedsTable[8];
  FCharHeight := 8;
  FCharWidth := 8;
  FTransparent := true;
end;


{================ TDigitClock ===================}
constructor TDigitClock.Create;
var
  i: Integer;
begin
  inherited;
  BevelOuter := bvNone; Caption := '';
  FTimer := TTimer.Create(Self);
  FTimer.OnTimer := ActTimer;
  FTimer.Interval := 1;
  for i := Low(FCharLeds) to High(FCharLeds) do begin
    FCharLeds[i] := TCharLed.Create(Self);
    FCharLeds[i].Parent := Self;
    FCharLeds[i].ParentColor := True;
    FCharLeds[i].Char:=12;
  end;
  FShowSeconds := True;
  FActive := True;
  FSpaceWidth := 4;
  CharBorderWidth := 1;
  CharHeight := 2;
  CharWidth := 2;
  Width := 90;
  Height := 25;
  BevelOuter:=bvRaised;
  BorderColor:=clGreen;
  Color := clBlack;
  Adjust;
end;

destructor TDigitClock.Destroy;
begin
  FTimer.Free;
  inherited;
end;

procedure TDigitClock.SetShowSeconds;
var
  i: Integer;
begin
  if FShowSeconds <> Value then begin
    FShowSeconds := Value;
    for i := 6 to 7 do FCharLeds[i].Visible := Value;
    if Value then ClientWidth := ClientWidth + FCharLeds[1].Width+2*SpaceWidth
    else ClientWidth := ClientWidth - FCharLeds[1].Width - 2*SpaceWidth;
  end;
end;

procedure TDigitClock.SetCharColor;
var
  i: Integer;
begin
  if CharColor <> Value then
    for i := Low(FCharLeds) to High(FCharLeds) do
      FCharLeds[i].CharColor := Value;
end;

function TDigitClock.GetCharColor;
begin
  result := FCharLeds[Low(FCharLeds)].CharColor;
end;

procedure TDigitClock.SetBorderColor;
var
  i: Integer;
begin
  if BorderColor <> Value then
    for i := Low(FCharLeds) to High(FCharLeds) do
      FCharLeds[i].BorderColor := Value;
end;

function TDigitClock.GetBorderColor;
begin
  result := FCharLeds[Low(FCharLeds)].BorderColor;
end;

procedure TDigitClock.SetCharWidth;
var
  i: Integer;
begin
  if CharWidth <> Value then
    for i := Low(FCharLeds) to High(FCharLeds) do
    if i>5 then FCharLeds[i].CharWidth := Value div 2
    else FCharLeds[i].CharWidth := Value;
end;

function TDigitClock.GetCharWidth;
begin
  result := FCharLeds[Low(FCharLeds)].CharWidth;
end;

procedure TDigitClock.SetCharBorderWidth;
var
  i: Integer;
begin
  if CharBorderWidth <> Value then
    for i := Low(FCharLeds) to High(FCharLeds) do
    if i>5 then FCharLeds[i].BorderWidth := Value div 2
    else FCharLeds[i].BorderWidth := Value;
end;

function TDigitClock.GetCharBorderWidth;
begin
  result := FCharLeds[Low(FCharLeds)].BorderWidth;
end;

procedure TDigitClock.SetCharHeight;
var
  i: Integer;
begin
  if CharHeight <> Value then
    for i := Low(FCharLeds) to High(FCharLeds) do
    if i>5 then FCharLeds[i].CharHeight := Value div 2
    else FCharLeds[i].CharHeight := Value;
end;

function TDigitClock.GetCharHeight;
begin
  result := FCharLeds[Low(FCharLeds)].CharHeight;
end;

procedure TDigitClock.Resize;
begin
  inherited;
  Adjust;
end;

procedure TDigitClock.Adjust;
var
  w, p, i, r, k: Integer;
  d            : double;
begin
  if FShowSeconds then begin k:=7; d:=5.5; end
  else begin k:=5; d:=4.5; end;
  w:=round((Width-(SpaceWidth*(k+1)))/d);
  r:=SpaceWidth;
  for i := Low(FCharLeds) to High(FCharLeds) do begin
    if i>5 then FCharLeds[i].Height := (Height - 2*SpaceWidth) div 2
    else FCharLeds[i].Height := Height - 2*SpaceWidth;
    if i=3 then FCharLeds[i].Width := w div 2
    else if i>5 then FCharLeds[i].Width := w div 2
    else FCharLeds[i].Width := w;
    FCharLeds[i].Top := SpaceWidth;
    FCharLeds[i].Left:= r;
    inc(r, SpaceWidth+FCharLeds[i].Width);
  end;
end;

procedure TDigitClock.SetActive;
begin
  if FActive <> Value then begin
    FTimer.Enabled := Value;
    FActive := Value;
  end;
end;

procedure TDigitClock.SetSpaceWidth;
begin
  if FSpaceWidth <> Value then begin
    FSpaceWidth := Value;
    Adjust;
  end;
end;

procedure TDigitClock.ActTimer;
var
  t: TDateTime;
  h: Integer;
const
  tick: array [0..1] of TChar = (10, 12);
begin
  t := Time;
  t := t * 24;
  h := Trunc(t);
  t := t - h;
  if h < 10 then FCharLeds[1].Char := 12
  else FCharLeds[1].Char := h div 10;
  FCharLeds[2].Char := TChar(h mod 10);

  t := t * 60;
  h := Trunc(t);
  t := t - h;
  FCharLeds[4].Char := TChar(h div 10);
  FCharLeds[5].Char := TChar(h mod 10);

  t := t * 60;
  h := Trunc(t);
  t := t - h;
  if ShowSeconds then begin
    FCharLeds[6].Char := TChar(h div 10);
    FCharLeds[7].Char := TChar(h mod 10);
  end;
  t := t * 2;
  h := Trunc(t);
  t := t - h;
  FCharLeds[3].Char := tick[h];
  FTimer.Interval:=Trunc((1-t)*500)+1;
end;

end.
